import 'dart:typed_data';
import '../lib/dartgl.dart';
import '../lib/dartgl_win.dart';

void main() {
  
  var window = createWindowSync(600, 400, "Dart+OpenGL!");
  showWindow(window);
  runWindow(window);
  
  var deviceContext = getDeviceContext(window);
  var context = createContext(deviceContext);
  makeContextCurrent(deviceContext, context);
  
  glClearColor(0.0, 0.4, 0.8, 0.0);
  
  var shader = glCreateShader(GL_VERTEX_SHADER);
  var text = r"""
#version 330

in vec3 in_Position;

void main(void)
{
  gl_Position = vec4(in_Position.x, in_Position.y, in_Position.z, 1.0);
}
  """;
  var lines = text.split("\r\n").map((l)=>l+"\r\n").toList();
  var lengths =  lines.map((l)=>l.length).toList();
  
  glShaderSource(shader, lines.length, lines, null);
  
  glCompileShader(shader);  
  
  var status = new Int32List.fromList([5]);
  glGetShaderiv(shader, GL_COMPILE_STATUS, status);
  if (status[0] != GL_TRUE){
    print("shader status ${status[0]}");
  }
  
  while(runWindow(window)){
    makeContextCurrent(deviceContext, context);
    
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  
    
    swapBuffers(deviceContext);
    
    makeContextCurrent(0, 0);
  }
  
}

